A. Rational Resistance----贪心

来源:互联网 发布:单片机方案公司 编辑:程序博客网 时间:2024/06/06 01:33

A. Rational Resistance
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Mad scientist Mike is building a time machine in his spare time. To finish the work, he needs a resistor with a certain resistance value.

However, all Mike has is lots of identical resistors with unit resistance R0 = 1. Elements with other resistance can be constructed from these resistors. In this problem, we will consider the following as elements:

  1. one resistor;
  2. an element and one resistor plugged in sequence;
  3. an element and one resistor plugged in parallel.

With the consecutive connection the resistance of the new element equals R = Re + R0. With the parallel connection the resistance of the new element equals . In this case Re equals the resistance of the element being connected.

Mike needs to assemble an element with a resistance equal to the fraction . Determine the smallest possible number of resistors he needs to make such an element.

Input

The single input line contains two space-separated integers a and b (1 ≤ a, b ≤ 1018). It is guaranteed that the fraction  is irreducible. It is guaranteed that a solution always exists.

Output

Print a single number — the answer to the problem.

Please do not use the %lld specifier to read or write 64-bit integers in С++. It is recommended to use the cincout streams or the%I64d specifier.

Examples
input
1 1
output
1
input
3 2
output
3
input
199 200
output
200
Note

In the first sample, one resistor is enough.

In the second sample one can connect the resistors in parallel, take the resulting element and connect it to a third resistor consecutively. Then, we get an element with resistance . We cannot make this element using two resistors.


题目链接:http://codeforces.com/contest/343/problem/A


从退了队就没有写过一篇博客,两个月没有写。。。感谢QAQ大大

这个题的意思是给你一些电阻为1的小电阻,让你通过串联和并联的方式来组成一个阻值为a/b的大电阻,现在我们考虑第三组数据,199/200,我们考虑并联,1/(1/199+1)不就是199/200,所以我们用199个电阻串联,然后并上一个1欧的电阻,大电阻的值就为199/200,所以我们逆向贪心回去即可,详见代码。

代码:

#include <cstdio>#include <cstring>#include <iostream>#define LL long longusing namespace std;int main(){    LL a,b;    scanf("%I64d%I64d",&a,&b);    LL sum=0;    while(1){        if(a<b){            swap(a,b);        }        LL k=a/b;        a-=k*b;        sum+=k;        if(a%b==0)            break;    }    printf("%I64d\n",sum);    return 0;}